﻿Type=Class
Version=2.00
@EndOfDesignText@
'Class module
Sub Class_Globals
Type NodeC(pnl As Panel, _
		   btn As Button, _
		   lbl As Label, _
		   IMG As ImageView, _
		   tag As String, _
		   level As Int, _
		   parent As Node, _
		   children As List)
Dim TN As NodeC
Private plus,minus As Bitmap
Private lh,lw As Int
Dim Cmodule As Object	
End Sub

'Initializes the object. 
'Module is the calling module
'parent is the parent Node
'level is one more then the parent's level
'linewidth is the width of the node's panel
'lineheight Is the height of the Node's panel
'Text is the node's label text
'img is the bitmap of the node
'tag and tag1 are tags for use with the control of the tree.
Sub Initialize(Module As Object, _
			   parent As Node, _
			   level As Int, _
			   linewidth As Int, _
			   lineheight As Int, _
			   Text As String, _
			   img As Bitmap, _
			   tag As String, _
			   tag1 As String)

lh = lineheight
lw = linewidth 
plus.Initialize(File.DirAssets,"plus2.png")
minus.Initialize(File.DirAssets,"minus2.png")
Cmodule = Module

TN.Initialize
TN.pnl.Initialize("")
TN.img.Initialize("lbl") ' will do the same action as the label.
TN.img.Gravity = Gravity.FILL
TN.btn.Initialize("btn")
If img <> Null Then TN.img.SetBackgroundImage(img) 
If tag1 = "plus" Then 
	TN.btn.SetBackgroundImage(plus)
Else 
	TN.btn.Visible = False
End If
TN.btn.tag = tag1
TN.lbl.Initialize("lbl")
TN.children.Initialize
If parent <> Null Then 
	TN.parent = parent
	TN.parent.TN.children.Add(Me)
End If
TN.lbl.Text = Text
TN.lbl.TextSize = 20

TN.tag = tag 
TN.level = 0 

TN.pnl.AddView(TN.btn,0.05*lh,0.05*lh,0.9*lh,0.9*lh)
TN.pnl.AddView(TN.img,lh* 1.2,0.05*lh,0.9*lh,0.9*lh)
TN.pnl.AddView(TN.lbl,2.5*lh,0.05*lh,lw-2.5*lh,0.9*lh)
TN.level = level
End Sub

Sub getTag
Return TN.tag
End Sub

Sub AsView As View
Return TN.pnl
End Sub

Sub btn_click
If TN.btn.tag = "plus" Then
	TN.btn.SetBackgroundImage(minus)
	TN.btn.tag = "minus"
	If SubExists(Cmodule,"Node_Open") Then
		CallSub2(Cmodule,"Node_Open",Me)
	End If
Else If TN.btn.tag = "minus" Then
	TN.btn.SetBackgroundImage(plus)
	TN.btn.tag = "plus"
		If SubExists(Cmodule,"Node_Close") Then
		CallSub2(Cmodule,"Node_Close",Me)
	End If
Else
	' do nothing
End If
End Sub

Sub lbl_click
If SubExists(Cmodule,"Node_Click") Then
	CallSub2(Cmodule,"Node_Click",Me)
End If
End Sub

Sub lbl_longclick
If SubExists(Cmodule,"Node_LongClick") Then
	CallSub2(Cmodule,"Node_longClick",Me)
End If
End Sub